#ifndef _RECIPY_H_
#define _RECIPY_H_

#include "obsdata.h"

/* flags telling what to add to recipy */
#define MKRCP_STD 1
#define MKRCP_TGT 2
#define MKRCP_FIELD 4
#define MKRCP_USER 8
#define MKRCP_DET 0x10
#define MKRCP_CAT 0x20
#define MKRCP_FIELD_TO_TGT 0x20
#define MKRCP_USER_TO_TGT 0x40
#define MKRCP_DET_TO_TGT 0x80
#define MKRCP_CAT_TO_STD 0x100


/* Structure describing tabular format fields */

struct col_format {
	int type;	/* what is being output - symbol value */
	int width;	/* column width */
	int precision;  /* precision for floating point outputs */
	void *data;	/* other description (band name for instance) */
};


typedef enum {
	RCP_STATE_START,
	RCP_STATE_TOPALIST,
	RCP_STATE_RCPALIST,
	RCP_STATE_STARLIST,
	RCP_STATE_FLAGS,
	RCP_STATE_SKIP,
	RCP_STATE_SKIP_LIST,
	RCP_STATE_SKIP_LIST_NEXT,
	RCP_STATE_END,
} RcpState;

/* a few helpers */
static inline int intval(GScanner *scan) {return (int)g_scanner_cur_value(scan).v_int;}
static inline double floatval(GScanner *scan) {return (double)g_scanner_cur_value(scan).v_float;}
static inline char * stringval(GScanner *scan) {return g_scanner_cur_value(scan).v_string;}

/* these shouldn't really be public, but report.c needs them */
GScanner* init_scanner();

int report_recipy(FILE *rfp, GSList *rsl, struct wcs *wcs, 
		  int flags, char *comment);
void test_parse_rcp(void);
int read_rcp(struct cat_star *cst[], FILE *fp, int n, double *ra, double *dec);
int read_avsomat_rcp(struct cat_star *cst[], FILE *fp, int n);
int convert_recipy(FILE *inf, FILE *outf);
int read_gsc2(struct cat_star *csl[], FILE *fp, int n, double *cra, double *cdec);
int convert_catalog(FILE *inf, FILE *outf, char *catname);
void report_to_table(FILE *inf, FILE *outf, char *format);
int read_obs_report(FILE *fp, struct cat_star *cst[], int n, 
		    struct obs_data *obst[], int no);


/* from report.c */
void report_to_table(FILE *inf, FILE *outf, char *format);
int recipy_to_aavso_db(FILE *inf, FILE *outf);


#endif
